"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _RowsPerPage = _interopRequireDefault(require("./RowsPerPage"));

var _paginationPages = _interopRequireDefault(require("../../helpers/pagination-pages"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DefaultPagination = /*#__PURE__*/function () {
  function DefaultPagination(proTable) {
    _classCallCheck(this, DefaultPagination);

    this.proTable = proTable;
    this.$dom = document.createElement('div');
    this.$dom.style.display = 'flex';
    this.$dom.style.justifyContent = 'space-between';
    this.$dom.style.alignItems = 'center';

    this._buildRowsPerPage();

    this._buildControls();

    this.render();
  }

  _createClass(DefaultPagination, [{
    key: "_buildRowsPerPage",
    value: function _buildRowsPerPage() {
      this.rowsPerPage = new _RowsPerPage["default"](this.proTable);
      this.$dom.appendChild(this.rowsPerPage.$dom);
    }
  }, {
    key: "_buildControls",
    value: function _buildControls() {
      var options = this.proTable.options;
      this.$controls = document.createElement(options.pagination.containerElement || 'div');
      this.$controls.style.margin = '0';

      if (options.pagination.containerClasses) {
        var _this$$controls$class;

        (_this$$controls$class = this.$controls.classList).add.apply(_this$$controls$class, _toConsumableArray(options.pagination.containerClasses));
      }

      this.$dom.appendChild(this.$controls);
      this.pageButtons = [];

      this._buildPrevButton();

      this._buildNextButton();

      this._buildPageButtons();
    }
  }, {
    key: "_buildNextButton",
    value: function _buildNextButton() {
      var _this = this;

      this.btnNext = this._buildButton('Next'); // apply classes from options

      if (this.proTable.options.pagination.btnClasses) {
        var _this$btnNext$$btn$cl;

        (_this$btnNext$$btn$cl = this.btnNext.$btn.classList).add.apply(_this$btnNext$$btn$cl, _toConsumableArray(this.proTable.options.pagination.btnClasses));
      }

      this.$controls.appendChild(this.btnNext.$wrapper);
      this.btnNext.$btn.addEventListener('click', function (e) {
        _this.proTable.setPage(_this.proTable.options.page + 1);
      });
    }
  }, {
    key: "_buildPrevButton",
    value: function _buildPrevButton() {
      var _this2 = this;

      this.btnPrev = this._buildButton('Prev'); // apply classes from options

      if (this.proTable.options.pagination.btnClasses) {
        var _this$btnPrev$$btn$cl;

        (_this$btnPrev$$btn$cl = this.btnPrev.$btn.classList).add.apply(_this$btnPrev$$btn$cl, _toConsumableArray(this.proTable.options.pagination.btnClasses));
      }

      this.$controls.appendChild(this.btnPrev.$wrapper);
      this.btnPrev.$btn.addEventListener('click', function (e) {
        _this2.proTable.setPage(_this2.proTable.options.page - 1);
      });
    }
  }, {
    key: "_buildPageButtons",
    value: function _buildPageButtons() {
      var _this3 = this;

      var options = this.proTable.options;
      var limit = options.limit;
      var totalRows = this.proTable.tbody.filteredTrs.length;
      var lastPage = Math.ceil(totalRows / limit);

      while (this.pageButtons.length) {
        var btn = this.pageButtons.pop();
        this.$controls.removeChild(btn.$wrapper);
      }

      (0, _paginationPages["default"])(options.page, lastPage, 2).forEach(function (page) {
        var btn = _this3._buildButton(page);

        if (page === options.page) {
          btn.$btn.style.fontWeight = 800;

          if (options.pagination.btnActiveClasses) {
            var _btn$$btn$classList;

            (_btn$$btn$classList = btn.$btn.classList).add.apply(_btn$$btn$classList, _toConsumableArray(options.pagination.btnActiveClasses));
          }

          if (options.pagination.btnWrapperActiveClasses) {
            var _btn$$wrapper$classLi;

            (_btn$$wrapper$classLi = btn.$wrapper.classList).add.apply(_btn$$wrapper$classLi, _toConsumableArray(options.pagination.btnWrapperActiveClasses));
          }
        } // apply classes from options


        if (options.pagination.btnClasses) {
          var _btn$$btn$classList2;

          (_btn$$btn$classList2 = btn.$btn.classList).add.apply(_btn$$btn$classList2, _toConsumableArray(options.pagination.btnClasses));
        }

        btn.$btn.addEventListener('click', function (e) {
          _this3.proTable.setPage(page);
        });

        _this3.pageButtons.push(btn);

        _this3.$controls.insertBefore(btn.$wrapper, _this3.btnNext.$wrapper);
      });
    }
    /**
     * Create DOM button
     * 
     * @returns { Object } object of $btn and $wrapper
     */

  }, {
    key: "_buildButton",
    value: function _buildButton(text) {
      var _options$pagination;

      var options = this.proTable.options;
      var $btn = document.createElement(((_options$pagination = options.pagination) === null || _options$pagination === void 0 ? void 0 : _options$pagination.btnElement) || 'button');
      $btn.innerText = text; // if there is a wrapper

      if (options.pagination.btnWrapper) {
        var $wrapper = document.createElement(options.pagination.btnWrapper);
        $wrapper.appendChild($btn);

        if (options.pagination.btnWrapperClasses) {
          var _$wrapper$classList;

          (_$wrapper$classList = $wrapper.classList).add.apply(_$wrapper$classList, _toConsumableArray(options.pagination.btnWrapperClasses));
        }

        return {
          $wrapper: $wrapper,
          $btn: $btn
        };
      }

      return {
        $btn: $btn,
        $wrapper: $btn
      };
    }
  }, {
    key: "render",
    value: function render() {
      var options = this.proTable.options;
      var limit = options.limit;
      var page = options.page;
      var start = (page - 1) * limit + 1;
      var to = start + limit - 1;
      var totalRows = this.proTable.tbody.filteredTrs.length;
      var lastPage = Math.ceil(totalRows / limit);
      this.btnPrev.$btn.disabled = page === 1;
      this.btnNext.$btn.disabled = page === lastPage;

      if (page === 1) {
        var _options$pagination2, _options$pagination2$;

        this.btnPrev.$wrapper.classList.add('disabled');

        if ((_options$pagination2 = options.pagination) === null || _options$pagination2 === void 0 ? void 0 : (_options$pagination2$ = _options$pagination2.btnDisabledClasses) === null || _options$pagination2$ === void 0 ? void 0 : _options$pagination2$.length) {
          var _this$btnPrev$$btn$cl2;

          (_this$btnPrev$$btn$cl2 = this.btnPrev.$btn.classList).add.apply(_this$btnPrev$$btn$cl2, _toConsumableArray(options.pagination.btnDisabledClasses));
        }
      } else {
        var _options$pagination3, _options$pagination3$;

        this.btnPrev.$wrapper.classList.remove('disabled');

        if ((_options$pagination3 = options.pagination) === null || _options$pagination3 === void 0 ? void 0 : (_options$pagination3$ = _options$pagination3.btnDisabledClasses) === null || _options$pagination3$ === void 0 ? void 0 : _options$pagination3$.length) {
          var _this$btnPrev$$btn$cl3;

          (_this$btnPrev$$btn$cl3 = this.btnPrev.$btn.classList).remove.apply(_this$btnPrev$$btn$cl3, _toConsumableArray(options.pagination.btnDisabledClasses));
        }
      }

      if (page === lastPage) {
        var _options$pagination4, _options$pagination4$;

        this.btnNext.$wrapper.classList.add('disabled');

        if ((_options$pagination4 = options.pagination) === null || _options$pagination4 === void 0 ? void 0 : (_options$pagination4$ = _options$pagination4.btnDisabledClasses) === null || _options$pagination4$ === void 0 ? void 0 : _options$pagination4$.length) {
          var _this$btnNext$$btn$cl2;

          (_this$btnNext$$btn$cl2 = this.btnNext.$btn.classList).add.apply(_this$btnNext$$btn$cl2, _toConsumableArray(options.pagination.btnDisabledClasses));
        }
      } else {
        var _options$pagination5, _options$pagination5$;

        this.btnNext.$wrapper.classList.remove('disabled');

        if ((_options$pagination5 = options.pagination) === null || _options$pagination5 === void 0 ? void 0 : (_options$pagination5$ = _options$pagination5.btnDisabledClasses) === null || _options$pagination5$ === void 0 ? void 0 : _options$pagination5$.length) {
          var _this$btnNext$$btn$cl3;

          (_this$btnNext$$btn$cl3 = this.btnNext.$btn.classList).remove.apply(_this$btnNext$$btn$cl3, _toConsumableArray(options.pagination.btnDisabledClasses));
        }
      }

      this._buildPageButtons();
    }
  }]);

  return DefaultPagination;
}();

var _default = DefaultPagination;
exports["default"] = _default;