"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ProTable = _interopRequireDefault(require("../table/ProTable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var RowsPerPage = /*#__PURE__*/function () {
  /**
   * 
   * @param { ProTable } proTable 
   */
  function RowsPerPage(proTable) {
    _classCallCheck(this, RowsPerPage);

    this.proTable = proTable;
    this.$dom = document.createElement('div');
    this.$dom.style.display = 'inline-flex';
    this.$dom.style.marginRight = '1rem';
    this.$dom.style.alignItems = 'center';

    this._createSpan();

    this._createSelect();
  }

  _createClass(RowsPerPage, [{
    key: "_createSpan",
    value: function _createSpan() {
      var _this$proTable$option, _this$proTable$option2, _this$proTable$option3;

      var span = document.createElement('span');
      span.innerText = ((_this$proTable$option = this.proTable.options) === null || _this$proTable$option === void 0 ? void 0 : (_this$proTable$option2 = _this$proTable$option.pagination) === null || _this$proTable$option2 === void 0 ? void 0 : (_this$proTable$option3 = _this$proTable$option2.rowsPerPage) === null || _this$proTable$option3 === void 0 ? void 0 : _this$proTable$option3.text) || 'Rows per page';
      span.style.marginRight = '1rem';
      this.$dom.appendChild(span);
    }
  }, {
    key: "_createSelect",
    value: function _createSelect() {
      var _options$pagination,
          _options$pagination$r,
          _options$pagination2,
          _options$pagination2$,
          _this = this;

      var options = this.proTable.options;
      var selectedLimit = options.limit;
      this.$select = document.createElement('select');
      this.$select.style.width = 'fit-content';

      if ((_options$pagination = options.pagination) === null || _options$pagination === void 0 ? void 0 : (_options$pagination$r = _options$pagination.rowsPerPage) === null || _options$pagination$r === void 0 ? void 0 : _options$pagination$r.selectClasses) {
        var _this$$select$classLi;

        (_this$$select$classLi = this.$select.classList).add.apply(_this$$select$classLi, _toConsumableArray(options.pagination.rowsPerPage.selectClasses));
      }

      var ranges = ((_options$pagination2 = options.pagination) === null || _options$pagination2 === void 0 ? void 0 : (_options$pagination2$ = _options$pagination2.rowsPerPage) === null || _options$pagination2$ === void 0 ? void 0 : _options$pagination2$.ranges) || [5, 10, 25, 50, 100, 250, 500]; // if selectedLimit doesn't exist in ranges array

      if (!ranges.find(function (_range) {
        return _range === selectedLimit;
      })) {
        ranges.push(selectedLimit);
      }

      ranges.sort(function (a, b) {
        return a - b;
      }).forEach(function (limit) {
        var option = document.createElement('option');
        option.value = limit;
        option.innerText = limit;
        option.selected = parseInt(selectedLimit) === limit;

        _this.$select.appendChild(option);
      });
      this.$select.addEventListener('change', function (e) {
        _this.proTable.setLimit(_this.$select.value);
      });
      this.$dom.appendChild(this.$select);
    }
  }]);

  return RowsPerPage;
}();

var _default = RowsPerPage;
exports["default"] = _default;