"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Tr = _interopRequireDefault(require("./Tr"));

var _Td = _interopRequireDefault(require("./Td"));

var _SimplePagination = _interopRequireDefault(require("../pagination/SimplePagination"));

var _DefaultPagination = _interopRequireDefault(require("../pagination/DefaultPagination"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var TFoot = /*#__PURE__*/function () {
  function TFoot(proTable) {
    var _this = this;

    _classCallCheck(this, TFoot);

    this.proTable = proTable;
    this.$dom = document.createElement('tfoot');
    this.trs = [];
    this.createPagination();
    this.trs.forEach(function (_tr) {
      return _this.$dom.appendChild(_tr.$dom);
    });
  }

  _createClass(TFoot, [{
    key: "createPagination",
    value: function createPagination() {
      var options = this.proTable.options;

      if (this.proTable.tbody.trs.length < this.proTable.options.limit || !!!options.pagination) {
        return;
      }

      if (options.pagination === 'simple' || options.pagination.type === 'simple') {
        this.pagination = new _SimplePagination["default"](this.proTable);
      } else {
        this.pagination = new _DefaultPagination["default"](this.proTable);
      }

      var columnsCount = this.proTable.thead.columnsCount;
      var tr = new _Tr["default"]();
      var td = new _Td["default"]({
        child: this.pagination.$dom,
        options: {
          attrs: {
            colspan: columnsCount
          },
          style: {
            textAlign: 'right'
          }
        }
      });
      tr.pushTd(td);
      this.trs.push(tr);
    }
  }, {
    key: "render",
    value: function render() {
      if (this.pagination) {
        this.pagination.render();
      }
    }
  }]);

  return TFoot;
}();

var _default = TFoot;
exports["default"] = _default;