"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.THead = exports["default"] = void 0;

var _Tr = _interopRequireDefault(require("./Tr"));

var _Th = _interopRequireDefault(require("./Th"));

var _ProTable = _interopRequireDefault(require("./ProTable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var THead = /*#__PURE__*/function () {
  /**
   * Creates an instance of THead.
   *
   * The params columns can be like: ["a", "b", { c: ["d", "e", "f"] }]
   * 
   * @param { Object } payload
   * @param { ProTable } payload.proTable
   * @param { Object } payload.options
   * @memberof THead
   * @constructor
   */
  function THead(_ref) {
    var _this = this;

    var proTable = _ref.proTable,
        options = _ref.options;

    _classCallCheck(this, THead);

    this.options = _objectSpread({
      thClasses: []
    }, options);
    this.proTable = proTable;
    this.$dom = document.createElement('thead');
    this.trs = this.generateTrs(this.proTable.columns);

    this.columnsCount = function () {
      return _this.trs[0].childs.map(function (th) {
        return th.options.attrs.colspan;
      }).reduce(function (a, b) {
        return a + b;
      });
    }();

    console.log('trs', this.trs); // append child

    this.trs.forEach(function (tr) {
      return _this.$dom.appendChild(tr.$dom);
    });
  }

  _createClass(THead, [{
    key: "generateTrs",
    value: function generateTrs(columns) {
      var trs = [];

      var _this$generateThs = this.generateThs(columns),
          ths = _this$generateThs.ths,
          childs = _this$generateThs.childs;

      var tr = new _Tr["default"]();
      ths.forEach(function (_th) {
        return tr.pushTh(_th);
      });
      trs.push(tr);
      console.log('childs', childs);

      if (Object.keys(childs).length) {
        trs = trs.concat(this.generateTrs(childs));
      } // add rowspan to th that has not colspan attr
      // and fix colspan as its child


      tr.childs.forEach(function (_th) {
        if (_th.options.attrs.colspan === 1) {
          _th.$dom.setAttribute('rowspan', trs.length);
        }
      });
      return trs;
    }
    /**
     * Generate th elements of the head
     * 
     * @param { Object } columns 
     */

  }, {
    key: "generateThs",
    value: function generateThs(columns) {
      var ths = [];
      var childs = {};

      for (var _key in columns) {
        var _col = columns[_key];
        ths.push(new _Th["default"]({
          key: _key,
          label: _col.label,
          proTable: this.proTable,
          options: {
            classes: this.options.thClasses.concat(_col.classes),
            attrs: {
              colspan: this.getColspan(_col.childs)
            },
            orderable: typeof _col.orderable === 'boolean' ? !!_col.orderable : true
          }
        }));

        if (_col.childs) {
          childs = _objectSpread(_objectSpread({}, childs), _col.childs);
        }
      }

      return {
        ths: ths,
        childs: childs
      };
    }
    /**
     * Return the count of colspan of a given childs
     * 
     * @param { Object } childs 
     */

  }, {
    key: "getColspan",
    value: function getColspan(childs) {
      if (!childs) {
        return 1;
      }

      var length = Object.keys(childs).length;

      for (var _key in childs) {
        if (childs[_key].childs) {
          length += this.getColspan(childs[_key].childs);
        }
      }

      return length;
    }
  }, {
    key: "render",
    value: function render() {
      this.trs.forEach(function (_tr) {
        _tr.childs.forEach(function (_child) {
          return _child.render();
        });
      });
    }
  }]);

  return THead;
}();

exports.THead = THead;
var _default = {
  THead: THead
};
exports["default"] = _default;