"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ProTable = _interopRequireDefault(require("./ProTable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * Th Options
 * 
 * @typedef { Object } Th.Options
 * @property { Object } attrs - DOM attributes
 * @property { Number } attrs.colspan - colspan of this th
 */

/**
 * Th class
 *
 * @class Th
 */
var Th = /*#__PURE__*/function () {
  /**
   * Creates an instance of Th.
   * 
   * @param { Object } payload
   * @param { string } payload.key
   * @param { string } payload.label
   * @param { ProTable } payload.proTable
   * @param { Th.Options } payload.options
   * @memberof Th
   */
  function Th(_ref) {
    var key = _ref.key,
        label = _ref.label,
        proTable = _ref.proTable,
        options = _ref.options;

    _classCallCheck(this, Th);

    this.key = key;
    this.label = label;
    this.proTable = proTable;
    this.$dom = document.createElement('th');
    /**
     * @type { Th.Options }
     */

    this.options = _objectSpread({
      attrs: {
        colspan: 1
      },
      orderabel: true
    }, options);

    this._createContainer();

    this._createSpan();

    this._applyAttributes();

    this._applyClasses();

    this._applyOrderable();
  }

  _createClass(Th, [{
    key: "_createContainer",
    value: function _createContainer() {
      this.$container = document.createElement('div');
      this.$container.style.display = 'flex';
      this.$container.style.justifyContent = 'space-between';
      this.$container.style.alignItems = 'center';
      this.$dom.appendChild(this.$container);
    }
  }, {
    key: "_applyAttributes",
    value: function _applyAttributes() {
      for (var attr in this.options.attrs) {
        this.$dom.setAttribute(attr, this.options.attrs[attr]);
      }
    }
  }, {
    key: "_applyClasses",
    value: function _applyClasses() {
      var _this$options$classes;

      if ((_this$options$classes = this.options.classes) === null || _this$options$classes === void 0 ? void 0 : _this$options$classes.length) {
        var _this$$dom$classList;

        (_this$$dom$classList = this.$dom.classList).add.apply(_this$$dom$classList, _toConsumableArray(this.options.classes));
      }
    }
  }, {
    key: "_createSpan",
    value: function _createSpan() {
      this.$spanLabel = document.createElement('span');
      this.$spanLabel.innerHTML = this.label || '-';
      this.$container.appendChild(this.$spanLabel);
    }
  }, {
    key: "_isOrderable",
    value: function _isOrderable() {
      return this.options.orderable && this.options.attrs.colspan === 1;
    }
  }, {
    key: "_applyOrderable",
    value: function _applyOrderable() {
      var _this = this;

      if (!this._isOrderable()) {
        return;
      }

      this.$container.style.cursor = 'pointer'; // caret top

      this.$spanTop = document.createElement('span');
      this.$spanTop.innerHTML = '▴';
      this.$spanTop.style.marginBottom = '-.3rem'; // caret bottom

      this.$spanBottom = document.createElement('span');
      this.$spanBottom.innerHTML = '▾';
      this.$spanBottom.style.marginTop = '-.3rem';
      this.$orderDom = document.createElement('div');
      this.$orderDom.appendChild(this.$spanTop);
      this.$orderDom.appendChild(this.$spanBottom);
      this.$orderDom.style.display = 'inline-flex';
      this.$orderDom.style.flexDirection = 'column';
      this.$orderDom.style.justifyContent = 'center';
      this.$orderDom.style.fontSize = '80%';
      this.$orderDom.style.height = '1rem';
      this.$orderDom.style.opacity = 0.3;
      this.$orderDom.style.marginLeft = '.5rem';
      this.$orderDom.style.userSelect = 'none';
      this.$container.appendChild(this.$orderDom);
      this.$dom.addEventListener('click', function (e) {
        _this._toggleOrder();
      });
    }
  }, {
    key: "_toggleOrder",
    value: function _toggleOrder() {
      var order = this.proTable.options.order;
      var payload = {
        key: this.key,
        direction: 'asc'
      };

      if (order.key === this.key) {
        payload.direction = order.direction === 'desc' ? 'asc' : 'desc';
      }

      this.proTable.setOrder(payload);
    }
  }, {
    key: "render",
    value: function render() {
      if (this._isOrderable()) {
        var order = this.proTable.options.order;
        this.$spanTop.style.visibility = order.key === this.key && order.direction === 'desc' ? 'hidden' : '';
        this.$spanBottom.style.visibility = order.key === this.key && order.direction === 'asc' ? 'hidden' : '';
      }
    }
  }]);

  return Th;
}();

var _default = Th;
exports["default"] = _default;