"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ProTable = _interopRequireDefault(require("../components/table/ProTable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fromDOMTable = function fromDOMTable(selector, options) {
  var dom = document.querySelector(selector);
  var columns = getColumnsFromDom(dom);
  var rows = getRowsFromDom(dom, columns);
  console.log({
    columns: columns
  });
  options = _objectSpread({
    classes: Array.from(dom.classList)
  }, options);
  var proTable = new _ProTable["default"](null, options);
  proTable.generateTable({
    columns: columns,
    rows: rows
  }); // replace the dom input

  dom.replaceWith(proTable.$dom);
  return proTable;
};

function getColumnsFromDom(table) {
  var firstTr = table.querySelector('thead tr');
  var columns = {};
  Array.from(firstTr.children).forEach(function (_child) {
    columns[_child.innerHTML] = {
      label: _child.innerHTML,
      classes: Array.from(_child.classList)
    };
  });
  return columns;
}

function getRowsFromDom(table, columns) {
  var trs = table.querySelectorAll('tbody tr');
  return Array.from(trs).map(function (_tr) {
    var row = {};
    Object.keys(columns).forEach(function (_column, _index) {
      row[_column] = [_tr.children[_index].innerHTML, {
        classes: Array.from(_tr.children[_index].classList)
      }];
    });
    return row;
  });
}

var _default = fromDOMTable;
exports["default"] = _default;